from abc import ABC, abstractmethod


class AbstractFieldDescriptor(ABC):
    """Abstract field validator. With inital default
    value.
    """

    def __init__(self, value=None, optional=False, **kwargs):
        if value is not None or optional:
            self.val = value
        self.kwargs = kwargs
        super().__init__()

    def __get__(self, obj, objtype):
        """Getter method"""

    def __set__(self, obj, val):
        """Setter method"""


class FieldDescriptor(AbstractFieldDescriptor):
    def __get__(self, obj, objtype):
        return self.val

    def __set__(self, obj, val):
        self.val = val

    def __set_name__(self, owner, name):
        self.name = name
