def retrieve_from_base(name, bases, order=0):
    try:
        base = bases[order]
    except KeyError:
        """Undefined behavior."""
        return None

    try:
        return base.__annotations__[name]
    except KeyError:
        """Multiple inheritance check."""
        return retrieve_from_base(order + 1)


def find_annotations(name, instance):
    try:
        annotations = instance.__annotations__[name]

    except KeyError:
        annotations = retrieve_from_base(name, instance.__class__.__bases__)

    return annotations


import typing


def check_type(type_hint, value):
    if isinstance(type_hint, typing._SpecialForm):
        return True  # Any
    actual_type = (
        type_hint.__origin__ if hasattr(type_hint, "__origin__") else type_hint
    )

    if isinstance(actual_type, typing._SpecialForm):
        actual_type = type_hint.__args__

    return isinstance(value, actual_type)


def kwargs_matcher(kwargs, matchables):
    for k, v in kwargs.items():
        if k in matchables.keys():
            matchables[k] = v
    return matchables
